<?php

namespace chillerlan\FastRoute\DataGenerator;

class GeneratorCCB extends DataGeneratorAbstract implements DataGeneratorInterface{

	protected $approxChunkSize = 30;

	public function processChunk(array $regexToRoutesMap):array{
		$routeMap = [];
		$regexes = [];
		$suffixLen = 0;
		$suffix = '';
		$count = count($regexToRoutesMap);
		
		foreach($regexToRoutesMap as $regex => $route){
			$suffixLen++;
			$suffix .= "\t";

			$regexes[] = '(?:'.$regex.'/(\t{'.$suffixLen.'})\t{'.($count - $suffixLen).'})';
			$routeMap[$suffix] = [$route->handler, $route->variables];
		}

		return [
			'regex'    => '~^(?|'.implode('|', $regexes).')$~',
			'routeMap' => $routeMap,
			'suffix'   => '/'.$suffix,
		];
	}
}
