<?php

namespace chillerlan\FastRoute\DataGenerator;

class GeneratorGCB extends DataGeneratorAbstract implements DataGeneratorInterface{

	protected $approxChunkSize = 10;

	public function processChunk(array $regexToRoutesMap):array{
		$routeMap = [];
		$regexes = [];
		$numGroups = 0;
		
		foreach($regexToRoutesMap as $regex => $route){
			$numVariables = count($route->variables);
			$numGroups = max($numGroups, $numVariables);

			$regexes[] = $regex.str_repeat('()', $numGroups - $numVariables);
			$routeMap[$numGroups + 1] = [$route->handler, $route->variables];

			++$numGroups;
		}

		return [
			'regex'    => '~^(?|'.implode('|', $regexes).')$~',
			'routeMap' => $routeMap,
		];
	}
}

