<?php

namespace chillerlan\FastRoute\DataGenerator;

class GeneratorGPB extends DataGeneratorAbstract implements DataGeneratorInterface{

	protected $approxChunkSize = 10;

	public function processChunk(array $regexToRoutesMap):array{
		$routeMap = [];
		$regexes = [];
		$offset = 1;
		
		foreach($regexToRoutesMap as $regex => $route){
			$regexes[] = $regex;
			$routeMap[$offset] = [$route->handler, $route->variables];
			
			$offset += count($route->variables);
		}

		return [
			'regex'    => '~^(?:'.implode('|', $regexes).')$~',
			'routeMap' => $routeMap,
		];
	}
}

