<?php

namespace chillerlan\FastRoute\Dispatcher;

class DispatcherCCB extends DispatcherAbstract implements DispatcherInterface{

	public function dispatchVariableRoute(array $routeData, string $uri):array{

		foreach($routeData as $data){

			if(!preg_match($data['regex'], $uri.$data['suffix'], $matches)){
				continue;
			}

			list($handler, $varNames) = $data['routeMap'][end($matches)];

			$vars = [];
			$i = 0;
			foreach($varNames as $varName){
				$vars[$varName] = $matches[++$i];
			}
			
			return [
				self::FOUND, 
				$handler, 
				$vars,
			];
		}

		return [self::NOT_FOUND];
	}

}
