<?php

namespace chillerlan\FastRoute\Dispatcher;

/**
 * Interface DispatcherInterface
 */
interface DispatcherInterface{
	
	/**
	 * Dispatches against the provided HTTP method verb and URI.
	 *
	 * Returns array with one of the following formats:
	 *
	 *     [self::NOT_FOUND]
	 *     [self::METHOD_NOT_ALLOWED, ['GET', 'OTHER_ALLOWED_METHODS']]
	 *     [self::FOUND, $handler, ['varName' => 'value', ...]]
	 *
	 * @param string $httpMethod
	 * @param string $uri
	 *
	 * @return array
	 */
	public function dispatch(string $httpMethod, string $uri):array;

	/**
	 * @param array $routeData
	 * @param string $uri
	 *
	 * @return array
	 */
	public function dispatchVariableRoute(array $routeData, string $uri):array;
	
}
